body{
    margin: 0;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
    overflow: hidden;
}
engworkbook{
    display: flex;
    flex-direction: column;
    width: 100vw;
    height: 100vh;
    background-color: white;
}

.workbook-info-header{
    height: 34px;
    width: 100vw;
    display: flex;
    flex-direction: row;
    padding: 0px 14px;
    background-color: #2183b2;
}

.info-header-button{
    height: 34px;
    width: 34px;
    display: flex;
    justify-content: center;
    align-items: center;
}

.info-header-button:hover{
    background-color: rgba(0,0,0,.2);
    cursor: pointer;
}

.workbook-name-container{
    display: flex;
    align-items: center;
    margin-left: 20px;
}

.workbook-name-container:hover{
    background-color: rgba(0,0,0,.2);
}

#workbook-name-input{
    background-color: rgba(0,0,0,0);
    text-align: right;
    border: none;
    outline: none;
    color: white;
    font-size: 16px;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
}

.workbook-name-text{
    color: white;
    font-size: 16px;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;

}

.eng-ribbon-list{
    height: 34px;
    width: 100vw;
    background-color: #F3F2F1;
    display: flex;
    flex-direction: row;
    padding: 0px 18px;
}
#eng-ribbon-collection{
    display: none;
}
.eng-ribbon-tab{
    font-size: 15px;
    text-align: center;
    display: flex;
    align-items: center;
    justify-content: center;
    height: 28px;
    padding: 0px 14px;
}
.eng-ribbon-tab:hover{
    background-color: #FAF9F8;
    height: 28px;
    cursor: pointer;
}
.eng-ribbon-active-tab{
    border-bottom: 3px solid #2183b2 ;
}
.eng-active-ribbon{
    background-color: #F3F2F1;
    position: relative;
    box-shadow: rgba(0,0,0,.2) 0px 10px 20px -8px;
    z-index: 1000;
    padding: 4px 14px;
    padding-top: 4px;
    width: 100vw;
    height: 92px;
    display: flex;
    flex-direction: row;
    justify-content: left;   
}
.eng-ribbon-group{
    padding: 0px 10px;
    height: 76px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    border-right: 1px solid rgb(50,50,50);
    margin-top: 4px;
}
.eng-ribbon-extension-points-container{
    display: flex;
    flex-direction: row;
}
.vertical-divider{
    border-left: 1px solid rgba(0,0,0,.2);
    margin: 5px;
}
.eng-ribbon-group-title{
    padding-top: 4px;
    margin: 0px;
    height: 20px;
    width: 100%;
    font-size: 14px;
    text-align: center;
}
.eng-ribbon-contents{
    height: 58px;
    /* width: 100%; */
    display: flex;
    justify-content: center;
    align-items: center;
}

.scroll{
    overflow: scroll;
}
.scroll-x{
    overflow-x: scroll;
}
.scroll-y{
    overflow-y: scroll;
}


.eng-ribbon-contents-grid{
    height: 58px;
    width: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
}
.eng-ribbon-contents-vt{
    height: 58px;
    padding-left: 10px;
    display: flex;
    flex-direction: column;
    align-items:flex-start;
}

.eng-ribbon-extension-point{
    /* flex-grow: 1; */
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    padding: 4px;
    overflow: hidden;
}
.eng-ribbon-extension-point-hz{
    width: 100%;
    /* height: 100%; */
    display: flex;
    justify-content: left;
    align-items: flex-start;
    flex-direction: row;
    padding: 0px;
    overflow: hidden;
}
.eng-ribbon-contents-grid>.eng-ribbon-extension-point{
    /* flex-grow: 1; */
    width: 100%;
    max-height: 25px;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: row;
    padding: 4px;
}
.eng-ribbon-extension-point:hover, .hover-darken:hover, .eng-ribbon-extension-point-hz:hover{
    background-color: rgba(0,0,0,.2);
    cursor: pointer;
}
.eng-ribbon-extension-point-hz .eng-ribbon-extension-point-label{
    margin-left: 5px;
    margin-top: auto;
    margin-bottom: auto;
}
.eng-ribbon-extension-point-icon{
    max-height: 42px;
    height: 80%;
    /* width: 100%; */
}
.eng-ribbon-extension-point-hz .eng-ribbon-extension-point-icon{
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100%;
}
.ext-pt-large{
    height: 80%;
}

.eng-ribbon-contents-grid .eng-ribbon-extension-point-icon{
    height: 24px;
    width: 24px;
}
.eng-ribbon-extension-point-label{
    margin: 0px;
    font-size: 12px;
}
.eng-ribbon-contents-grid .eng-ribbon-extension-point-label{
    height: 20px;
    width: 20px;
    display: none;
}

.formula-bar-container{
    background-color: #E6E6E6;
    height: 45px;
    padding: 6px;
    width: 100vw;
    display: flex;
    align-items: center;
    flex-direction: row;
}

#selected-cell-info-bar{
    background-color: white;
    width: 25%;
    height: 25px;
    margin-left: 10px;
    border: 1px solid #9D9D9D;
    display: flex;
    align-items: center;
    white-space: nowrap;
    overflow: hidden;
    padding-left: 5px;
}
#function-icon{
    margin-left: 25px;
    font-style: italic;
    margin-right: 2px;
    display: flex;
    align-items: center;
}
#formula-bar-div{
    /* position: relative; */
    background-color: white;
    border: 1px solid #9D9D9D;
    height: 25px;
    width: 55%;
}
#formula-bar{
    display: flex;
    align-items: center;
    padding-left: 5px;
    overflow: hidden;
    white-space: nowrap;
    width: 100%;
    height: 23px;
    position: relative;
    top: -25px;
}
#formula-bar-input{
    padding-left: 5px;
    outline: none;
    border: none;
    height: 25px;
    background-color: rgba(0,0,0,0);
    width: 100%;
}
#formula-bar-input:focus{
    z-index: 2000;
    position: relative;
}

.spreadsheet-formula-bar-suggestions-container{
    position: relative;
    z-index: 2000;
    margin-top: -24px;
    background-color: white;
}

.function-bar-tooltip{
    position: relative;
    z-index: 2000;
    display: flex;
    flex-direction: row;
    background-color: #fffefe;
    padding: 4px 10px 4px 4px;
    height: 22px;
    margin-left: 15px;
    font-size: 12px;

}

.worksheet{
    position: relative;
    top: 0px;
    left: 0px;
    width: 0px;
    overflow: scroll;
}

.sheet-selection-footer{
    height: 36px;
    width: 100vw;
    padding: 0px 14px;
    background-color: #F3F2F1;
    position: relative;
    display: flex;
    flex-direction: row;
    border-top: 1px solid #999999;
}

.engsheets-footer{
    height: 10px;
    width: 100vw;
    background-color: #F3F2F1;
    position: absolute;
    bottom: 0;
    display: flex;
    flex-direction: row;
}
#sheet-selection-container{
    display: flex;
    flex-direction: row;
    height: 100%;
}
.sheet-select-button{
    margin-top: 8px;
    margin-bottom: 0px;
    padding: 0px 10px;
    font-size: 12px;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
    border-right: 1px solid #999999;
    display: flex;
}
.sheet-select-button:hover{
    cursor: pointer;
    font-weight: bold;
}
.sheet-select-button.active-sheet-selector{
    margin-top: -1px;
    padding-top: 8px;
    border: 1px solid #999999;
    border-top: 1px solid white;
    background-color: #fff;
}
.sheet-rename-input{
    border: none;
    outline: none;
    display: none;
}
.sheet-select-cover{
    position: relative;
}

#active-sheet, .active-sheet{
    position: relative;
    /* width: 100vw; */
    height: 100%;
    flex-grow: 1;
    overflow: scroll;
}

#worksheet-collection{
    position: relative;
    /* width: 100vw; */
    display: flex;
    flex-direction: row;
    flex-grow: 1;
}

#column-label-row{
    position: relative;
    z-index: 999;
    width: -moz-fit-content;
    width: fit-content;
    display: flex;
    flex-direction: row;
}
.column-header{
    width: 80px;
    background-color: #E6E6E6;
    border-bottom: 1px solid #9D9D9D;
    border-right: 1px solid #9D9D9D;
    text-align: center;
    z-index: 999;
    margin: 0px;
    -webkit-user-select: none;
    user-select: none;
    position: relative;
}

.column-resize{
    position: absolute;
    width: 5px;
    height: 100%;
    top: 0px;
    right: 0px;
}
.row-resize{
    position: absolute;
    width: 100%;
    height: 5px;
    bottom: 0px;
    left: 0px;
}
.column-resize:hover{
    cursor:ew-resize;
}
.row-resize:hover{
    cursor:ns-resize;
}

.row-header{
    background-color: #E6E6E6;
    border-bottom: 1px solid #9D9D9D;
    border-right: 1px solid #9D9D9D;
    text-align: center;
    position: relative;
    z-index: 20;
    margin: 0px;
    width: 30px;
    -webkit-user-select: none;
    user-select: none;
}
#spreadsheet-corner{
    /* position: relative;
    z-index: 1111;
    background-color: #E6E6E6;
    border-bottom: 1px solid #9D9D9D;
    border-right: 1px solid #9D9D9D;
    text-align: center;
    margin: 0px;
    width: 30px;
    -webkit-user-select: none;
    user-select: none; */
    width: 30px;
    background-color: #E6E6E6;
    border-bottom: 1px solid #9D9D9D;
    border-right: 1px solid #9D9D9D;
    text-align: center;
    z-index: 1000;
    margin: 0px;
    -webkit-user-select: none;
    user-select: none;
    position: relative;
}
.spreadsheet-row{
    /* position: relative; */
    z-index: auto;
    width: -moz-fit-content;
    height: 21.11px;
    width: fit-content;
    display: flex;
    flex-direction: row;
}
.spreadsheet-cell{
    width: 80px;
    /* background-color: #fff; */
    border: none;
    border-bottom: 1px solid #9D9D9D;
    border-right: 1px solid #9D9D9D;
    text-align: left;
    position: relative;
    /* z-index: 1; */
    margin: 0px;
    display: flex;
}

.cell-selected{
    z-index: 100;
}
.cell-selected>.spreadsheet-cell-cover{
    border: 2px solid #2183b2;
}
.spreadsheet-cell.cell-selected .spreadsheet-cell-input{
    background-color: white;
}
.spreadsheet-cell.cell-selected .spreadsheet-cell-cover{
    width: max-content;
    min-width: 100%;
    /* border: 2px solid #2183b2; */
}

.spreadsheet-cell[data-object] .spreadsheet-cell-input, .spreadsheet-cell[data-object] .spreadsheet-cell-cover{
    margin-left: 25px;
}
.spreadsheet-cell[data-object=null] .spreadsheet-cell-input, .spreadsheet-cell[data-object=null] .spreadsheet-cell-cover{
    margin-left: 0px;
}
.spreadsheet-cell-input{
    border: none;
    background-color: rgba(255,255,255,0);
    width: 100%;
    height: 90%;
    position: relative;
}

.spreadsheet-cell-cover{
    padding: 0px 2px;
    position: absolute;
    background-color: rgba(255,255,255,0);
    overflow: hidden;
    -webkit-user-select: none;
    -moz-user-select: none;
    user-select: none;
    height: 100%;
    width: 100%;
    top: 0px;
    left: 0px;
    z-index: 1;
    display: flex;
}
.object-icon{
    visibility: hidden;
    height: 20px;
    width: 20px;
    position: absolute;
    z-index: 11;
}

.object-display-container{
    position: absolute;
    top: 100%;
    background-color: white;
    border: 1px solid rgb(50,50,50);
    overflow: scroll;
    z-index: 2000;
    width: -moz-fit-content;
    width: fit-content;
}
.object-display-container div{
    margin-left: 10px;
}

.object-display-key-value-pair{
    display: grid;
    width: 100%;
    grid-template-columns: 1fr 1fr;
    border-bottom: 1px solid #dadada;
}
.object-display-value-p{
    padding-right: 10px;
    font-weight: bold;
}

.hidden{
    visibility: hidden;
}

.spreadsheet-cell[data-object] .object-icon{
    visibility: visible;
}
.spreadsheet-cell[data-object=null] .object-icon{
    visibility: hidden;
}
.spreadsheet-cell[data-object] .object-icon:hover{
    border: 1px solid #dadada;
    cursor: pointer;
}

.filled-cell .spreadsheet-cell-cover{
    /* padding-right: 20px; */
    background-color: white;
    z-index: 1;
    white-space: nowrap;
}
.spreadsheet-cell-input:focus{
    border: none;
    outline: none;
    z-index: 3;
    background-color: white;
}

.spreadsheet-cell-suggestions-container{
    position: absolute;
    top: 100%;
    left: 0px;
    overflow: scroll;
    overflow-x: hidden;
    display: flex;
    flex-direction: column;
    background-color: white;
    min-width: 200px;
    max-height: 250px;
}

.spreadsheet-cell-suggestion{
    width: 100%;
    font: 12px 'Segoe UI';
    padding: 2px 5px;
}

.spreadsheet-cell-suggestion:hover{
    background-color: #cfcfcf;
    cursor: pointer;
}

/* SHAPES */

.spreadsheet-shape{
    position: absolute;
    background-repeat: no-repeat;
    background-size: cover;
    height: auto;
    width: auto;
    cursor: grab;
    z-index: 101;
}

.spreadsheet-shape img{
    width: 100%;
    height: 100%;
}
.shape-modify>.resize-dot{
    background-color: white;
    height: 15px;
    width: 15px;
    border: 1px solid #656565;
    border-radius: 7.5px;
    position: absolute;
    bottom: -7.5px;
    right: -7.5px;
}
.resize-dot:hover{
    cursor: nwse-resize;
}

.shape-modify{
    border: 1px solid #656565;
}

.highlighted-suggestion{
    background-color: #2183b2;
}

.function-tooltip{
    position: absolute;
    background-color: #eeeeee;
    display: flex;
    flex-direction: row;
    padding: 4px 10px 4px 4px;
    height: 22px;
    bottom: -25px;
    margin-left: 15px;
    font-size: 12px;
}

.function-tooltip-param{
    margin-left: 5px;
}

.function-tooltip-current-param{
    font-weight: bold;
}

.cell-in-formula{
    border: 2px dotted red;
}


.cell-in-formula-inner{
    border-left: 2px dotted red;
    border-right: 2px dotted red;
}

.spill-border-left{
    border-left: #2183b2 dashed 2px
}
.spill-border-top{
    border-top: #2183b2 dashed 2px
}
.spill-border-right{
    border-right: #2183b2 dashed 2px
}
.spill-border-bottom{
    border-bottom: #2183b2 dashed 2px
}

#cell-drag-node{
    width: 8px;
    height: 8px;
    position: absolute;
    background-color: #2183b2;
    right: -4px;
    bottom: -4px;
    z-index: 10;
}
#cell-drag-node:hover{
    cursor:crosshair;
}

.drag-selected-cell{
    border: #2e8b2e 1px dashed;
}

.merge-master{
    /* border: 1px solid rgb(50,50,50); */
    /* z-index: 1000; */
}

.merge-slave{
    display: none;
}


.msgbox-container{
    background-color: #fff;
    border: 1px solid #707070;
    min-width: 180px;
    min-height: 150px;
    box-shadow: 0px 0px 10px 1px rgba(0,0,0,.5);
    display: flex;
    flex-direction: column;
    padding-top: 5px;
}

.msgbox-header{
    display: flex;
    flex-direction: row;
    position: relative;
}

.msgbox-label{
    flex-grow: 1;
    padding-left: 10px;
    font-size: 18px;
}

.close-button{
    width: 25px;
    height: 20px;
    display: relative;
    text-align: center;
    right: 0px;
    background-color: rgba(0,0,0,0);
    border: none;
    outline: none;
}
.close-button:hover{
    color: white;
    cursor: pointer;
    background-color: #E81123;
}

.msgbox-content{
    flex-grow: 1;
    padding: 10px;
    display: flex;
    align-items: center;
}
.msgbox-button{
    width: 100%;
    font-size: 16px;
    padding: 3px;
}
.msgbox-button:focus{
    outline: 2px solid #0078D7;
    border: 1px dotted black;
}
.msgbox-button-container-one{
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    padding: 0px 10% 10px 20%;
    position: relative;
}

.cell-style-ribbon-element>p{
    width: 100%;
}
.cell-style-ribbon-element{
    height: 25px;
    width: 100px;
    margin: 5px;
}
.cell-style-ribbon-element:hover{
    border: 2px solid #dadada;
}
.cell-style-normal{
    background-color: white;
    color: black;
}
.cell-style-bad{
    background-color: #FFC7CE;
    color: #9C0006;
}
.cell-style-good{
    background-color: #C6EFCE;
    color: #006100 
}
.cell-style-neutral{
    background-color: #FFEB9C;
    color: #AD5700;
}
.cell-style-normal:hover{
    background-color: white;
}
.cell-style-bad:hover{
    background-color: #FFC7CE;
}
.cell-style-good:hover{
    background-color: #C6EFCE;
}
.cell-style-neutral:hover{
    background-color: #FFEB9C;
}

.input-box-input-container{
    display: grid;
    grid-template-columns: 1fr 2fr;
    padding: 0px 20px;
    margin-bottom: 5px;
}
.input-box-input-container>label{
    display: flex;
    align-items: center;
    margin-right: 10px;
}
.input-box-form-container{
    display: flex;
    flex-direction: column;
}

.taskpane-container{
    height: 100%;
    min-width: 360px;
    background-color: #E6E6E6;
    padding: 20px;
    padding-left: 5px;
    display: flex;
    position: relative;
}

.taskpane-iframe{
    background-color: #f3f3f3;
    height: 100%;
    width: 100%;
    margin-left: 5px;
}

.resize-taskpane{
    width: 10px;
    height: 95%;
    position: relative;
    border-left: 1px solid #9D9D9D;
}
.resize-taskpane{
    cursor: ew-resize;
}

.taskpane-header-container{
    display: flex;
    flex-direction: row;
    flex-grow: 1;
}
.taskpane-heading{
    flex-grow: 1;
    margin-bottom: 5px;
}
.taskpane-close-button{
    height: 80%;
    font-size: 20px;
    text-align: center;
}

.context-menu{
    background-color: white;
    border: 1px solid #9d9d9d;
    width: 150px;
    position: absolute;
    display: flex;
    flex-direction: column;
    z-index: 11000;
}
.context-menu-button{
    width: 100%;
    background-color: white;
    border: none;
    padding: 5px 10px;
    text-align: left;
}

.context-menu-label{
    font-weight: 500;
    padding: 5px 0px 2px 0px;
    margin: 0px 5px 3px 5px;
    border-bottom: 1px solid #9d9d9d;
}

.taskpane-video-container{
    height: 100vh;
    width: 100vw;
    display: flex;
    justify-content: center;
    align-items: center;
}

#taskpane-video{
    width: 100%;
    height: 100%;
}